//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include <iostream.h>
#include <fstream.h>
#include <math.h>;
#include <stdlib.h>
#include "XYZTest00.h"
#include "about.h"
//---------------------------------------------------------------------------
#pragma link "txyzplot"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
   SetLabels();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SetLabels(void)
{
   PhiLabel->Caption = double(PhiBar->Position)/1000;;
   PsiLabel->Caption = double(PsiBar->Position)/1000;;
   ThetaLabel->Caption = double(ThetaBar->Position)/1000;;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
   double z[1][3];
   double z2[1][3];
   double phi=0;
   double theta = 0;
   double psi = 0;

   if(PhiBox->Checked)
      phi = double(PhiBar->Position)/1000;
   if(PsiBox->Checked)
      psi = double(PsiBar->Position)/1000;
   if(ThetaBox->Checked)
      theta = double(ThetaBar->Position)/1000;
   SetLabels();
   if((PhiBox->Checked)||(PsiBox->Checked)||(ThetaBox->Checked))
      XYZPlot1->SetAngles(XYZPlot1->Phi+phi,XYZPlot1->Theta+theta,XYZPlot1->Psi+psi);
   if(BouncingBall->Checked)
   {
       if(((ballx+deltax)>XYZPlot1->XMax)||((ballx+deltax)<XYZPlot1->XMin))
          deltax = -deltax;
       if(((bally+deltay)>XYZPlot1->YMax)||((bally+deltay)<XYZPlot1->YMin))
          deltay = -deltay;
       if(((ballz+deltaz)>XYZPlot1->ZMax)||((ballz+deltaz)<XYZPlot1->ZMin))
          deltaz = -deltaz;
       ballx += deltax;
       bally += deltay;
       ballz += deltaz;
       z[0][0] = ballx;
       z[0][1] = bally;
       z[0][2] = ballz;
       z2[0][0] = ballx;
       z2[0][1] = bally;
       z2[0][2] = XYZPlot1->ZMin;
       XYZPlot1->XYZPlot(z,1,0,psPoints,clBlue,clBlue);
       XYZPlot1->XYZPlot(z2,1,1,psPoints,clBlack, clBlack);
       XYZPlot1->Redraw();
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Graph1Click(TObject *Sender)
{
    int i;
    ifstream infile;

    infile.open("matrix.dat");
    for(i=0;i<400;i++)
          infile >> z[i];
    infile.close();

    if(Sender==Graph1)
    {
       XYZPlot1->RemovePlot(1);
       XYZPlot1->RemovePlot(2);
       XYZPlot1->XYZPlot(z,20,20,0,psSurface,clNavy,clOlive);
       Surface1->Checked=true;
    }
    else
    {
       XYZPlot1->XYZPlot(z,20,20,0,psGrid,clNavy);
       Grid1->Checked=true;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Exit1Click(TObject *Sender)
{
   Application->Terminate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Plot11Click(TObject *Sender)
{
   if(ColorDialog1->Execute())
   {
      if(Sender==Plot11)
         XYZPlot1->SetPlotLineColor(ColorDialog1->Color);
      else if (Sender==Fill1)
         XYZPlot1->SetPlotFillColor(ColorDialog1->Color);
      else if (Sender == XAxis1)
         XYZPlot1->XAxisColor = ColorDialog1->Color;
      else if (Sender == YAxis1)
         XYZPlot1->YAxisColor = ColorDialog1->Color;
      else if (Sender == ZAxis1)
         XYZPlot1->ZAxisColor = ColorDialog1->Color;
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Graph2Click(TObject *Sender)
{
   double z[400][3];
   int i;

   for(i=0;i<400;i++)
   {
      z[i][0] = double(i-200)/10.0*sin(double(i-200)/10.0);
      z[i][1] = double(i-200)/10.0*cos(double(i-200)/10.0);
      z[i][2] = double(i-200)/10.0;
   }
   if(Sender==Graph2)
   {
      XYZPlot1->XYZPlot(z,400,0,psLinesPoints,clGreen,clAqua);
      XYZPlot1->RemovePlot(1);
      XYZPlot1->RemovePlot(2);
      LinesPoints1->Checked=true;
   }
   else
   {
      XYZPlot1->XYZPlot(z,400,1,psLinesPoints,clGreen,clAqua);
      LinesPoints1->Checked=true;
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AutoScaleClick(TObject *Sender)
{
   XYZPlot1->AutoScale = AutoScale->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FitToScreenClick(TObject *Sender)
{
   XYZPlot1->FitToScreen = FitToScreen->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BothClick(TObject *Sender)
{
   Graph1Click(Both);
   Graph2Click(Both);
   Graph4Click(Both);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton3Click(TObject *Sender)
{
      XYZPlot1->Phi += double(PhiBar->Position)/1000;
      SetLabels();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton2Click(TObject *Sender)
{
      XYZPlot1->Theta += double(ThetaBar->Position)/1000;
      SetLabels();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton1Click(TObject *Sender)
{
      XYZPlot1->Psi += double(PsiBar->Position)/1000;
      SetLabels();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PerspectiveOnClick(TObject *Sender)
{
    VanishingPoint->Enabled = PerspectiveOn->Checked;
    XYZPlot1->PerspectiveOn = PerspectiveOn->Checked;
    VanishingPoint->Position = XYZPlot1->VanishingPoint;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::VanishingPointChange(TObject *Sender)
{
   XYZPlot1->VanishingPoint = VanishingPoint->Position;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ShowLabelsClick(TObject *Sender)
{
   XYZPlot1->ShowLabels = ShowLabels->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BouncingBallClick(TObject *Sender)
{
   BoxButton->Checked = true;
   Auto1->Checked = !(BouncingBall->Checked);
   XYZPlot1->AutoRedraw = !(BouncingBall->Checked);
   ShowLabels->Checked =!(BouncingBall->Checked);
   AutoScale->Checked = !(BouncingBall->Checked);
   Graph1->Enabled = !(BouncingBall->Checked);
   Graph2->Enabled = !(BouncingBall->Checked);
   Graph3->Enabled = !(BouncingBall->Checked);
   Graph4->Enabled = !(BouncingBall->Checked);
   RandomData->Enabled = !(BouncingBall->Checked);
   Both->Enabled = !(BouncingBall->Checked);
   AutoScale->Enabled=!(BouncingBall->Checked);
   ShowLabels->Enabled = !(BouncingBall->Checked);
   Style1->Enabled =!(BouncingBall->Checked);
   Color1->Enabled = !(BouncingBall->Checked);
   XYZPlot1->RemovePlot(2);
   ballx = (XYZPlot1->XMin+XYZPlot1->XMax)/2;
   bally = XYZPlot1->YMin;
   ballz = XYZPlot1->ZMin;
   deltax = (XYZPlot1->XMax-XYZPlot1->XMin)/60;
   deltay = (XYZPlot1->YMax-XYZPlot1->YMin)/70;
   deltaz = (XYZPlot1->ZMax-XYZPlot1->YMin)/80;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MouseControlClick(TObject *Sender)
{
   XYZPlot1->MouseControl = MouseControl->Checked;
   DragButton->Enabled = MouseControl->Checked;
   ZoomButton->Enabled = MouseControl->Checked;
   RotateButton->Enabled = MouseControl->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RotateButtonClick(TObject *Sender)
{
    if (Sender==ZoomButton)
       XYZPlot1->MouseFunction = mfZoom;
    else if(Sender==DragButton)
       XYZPlot1->MouseFunction = mfDrag;
    else if(Sender==RotateButton)
       XYZPlot1->MouseFunction = mfRotate;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ResetClick(TObject *Sender)
{
   XYZPlot1->Phi = 5.3;
   XYZPlot1->Theta = 0.0;
   XYZPlot1->Psi = 0.4;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Points1Click(TObject *Sender)
{
   if(Sender==Points1)
   {
      XYZPlot1->SetPlotStyle(psPoints,0);
      Points1->Checked=true;
   }
   if(Sender==Lines1)
   {
      XYZPlot1->SetPlotStyle(psLines,0);
      Lines1->Checked=true;
   }
   if(Sender==LinesPoints1)
   {
      XYZPlot1->SetPlotStyle(psLinesPoints,0);
      LinesPoints1->Checked=true;
   }
   if(Sender==Grid1)
   {
      XYZPlot1->SetPlotStyle(psGrid,0);
      Grid1->Checked=true;
   }
   if(Sender==Surface1)
   {
      XYZPlot1->SetPlotStyle(psSurface,0);
      Surface1->Checked=true;
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RandomDataClick(TObject *Sender)
{
   double z[50][3];
   int i;

   for(i=0;i<50;i++)
   {
      z[i][0] = random(1000)/10.0;
      z[i][1] = random(1000)/10.0;
      z[i][2] = random(1000)/10.0;
   }
   XYZPlot1->XYZPlot(z,50,0,psPoints,clGreen,clAqua);
   XYZPlot1->RemovePlot(1);
   XYZPlot1->RemovePlot(2);
   Points1->Checked=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Graph3Click(TObject *Sender)
{
    int i;
    ifstream infile;

    infile.open("sinc.dat");
    for(i=0;i<900;i++)
          infile >> z[i];
    infile.close();

    XYZPlot1->RemovePlot(1);
    XYZPlot1->RemovePlot(2);
    XYZPlot1->XYZPlot(z,30,30,-1,1,-1,1,0,psGrid,clNavy,clLime);
    Grid1->Checked=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Graph4Click(TObject *Sender)
{
   double z[400][3];
   int i;

   for(i=0;i<200;i++)
   {
      z[i][0] = double(i)/10.0*sin(double(i)/10.0);
      z[i][1] = double(i)/10.0*cos(double(i)/10.0);
      z[i][2] = double(i)/10.0*cos(double(i)/10.0)+2*cos(double(i)/2);
   }
   if(Sender==Graph4)
   {
      XYZPlot1->XYZPlot(z,200,0,psLines,clMaroon,clYellow);
      XYZPlot1->RemovePlot(1);
      XYZPlot1->RemovePlot(2);
      Lines1->Checked=true;
   }
   else if (Sender==Both)
   {
      XYZPlot1->XYZPlot(z,200,2,psLines,clMaroon,clYellow);
   }

}
//---------------------------------------------------------------------------
void __fastcall TForm1::NoneButtonClick(TObject *Sender)
{
   if (Sender==NoneButton)
      XYZPlot1->AxisStyle = asNone;
   else if (Sender==XYZButton)
      XYZPlot1->AxisStyle = asXYZ;
   else if (Sender==XYZPlaneButton)
      XYZPlot1->AxisStyle = asXYZPlane;
   else if (Sender==BoxButton)
      XYZPlot1->AxisStyle = asBox;
   else if (Sender==BoxAndPlaneButton)
      XYZPlot1->AxisStyle = asBoxAndPlane;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OriginBoxClick(TObject *Sender)
{
   XYZPlot1->ShowOrigin = OriginBox->Checked;	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Visible1Click(TObject *Sender)
{
   if (!(Visible1->Checked))
      if (ClientWidth<Panel1->Width)
      {
         ClientWidth = Panel1->Width;
         ClientHeight = Panel1->Width;
      }
   Visible1->Checked = !(Visible1->Checked);
   Panel1->Visible = Visible1->Checked;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Auto1Click(TObject *Sender)
{
   Auto1->Checked = !(Auto1->Checked);
   XYZPlot1->AutoRedraw = Auto1->Checked;	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RedrawScreen1Click(TObject *Sender)
{
   XYZPlot1->Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::About1Click(TObject *Sender)
{
   AboutBox->ShowModal();
}
//---------------------------------------------------------------------------
